<script type="text/javascript" src="/js/cubix-ui-v1.0.source.js"></script>
<script type="text/javascript" src="/js/cubix-button-v1.0.source.js"></script>
<script type="text/javascript" src="/js/cubix-shadow-v1.0.source.js"></script>
<script type="text/javascript" src="/js/cubix-popup-v3.0.source.js"></script>
<script type="text/javascript" src="/js/cubix-grid-v2.0.source.js?v=3"></script>
<script type="text/javascript" src="/js/mootabs1.2.js"></script>
<script type="text/javascript" src="/js/datepicker.js"></script>


<script type="text/javascript">
Cubix.ready = function () {
    var pickerFrom = new Picker.Date('input[name=date_fromaa]', {
        pickerClass: 'datepicker',
        positionOffset: {x: -10, y: 0}, allowEmpty: true, format: 'd M Y'
    });
    var pickerTo = new Picker.Date('input[name=date_toaa]', {
        pickerClass: 'datepicker',
        positionOffset: {x: -10, y: 0}, allowEmpty: true, format: 'd M Y'
    });

    var pickerSelect = function (d) {
        var dp1, dp2;

        if (pickerTo.visual && pickerTo.visual.get('value').length && pickerTo.d &&
            pickerFrom.visual && pickerFrom.visual.get('value').length && pickerFrom.d) {
            dp1 = pickerFrom;
            dp2 = pickerTo;
        }

        if (dp1 && dp2) {
            if (dp1.d > dp2.d) {
                this.choice = {};
                this.d = null;
                this.input.set('value', '');
                this.visual.set('value', '');
                alert('Please select valid date range');
            }
        }
    };


    pickerFrom.addEvent('select', pickerSelect);
    pickerTo.addEvent('select', pickerSelect);

    new Cubix.Button($('btn-total'), { onClick: function () {
        popupCount.setTitle('Total Transfers');
        popupCount.load('/billing/cam-tokens/data-total?type=total_t&' + $('search-form').toQueryString(), function () {
            this.open();
        });
    }, icon: 'money_dollar', caption: 'Total Amount', classes: 'ml20' });

    // if ( $('btn-total') ){
    //     new Cubix.Button($('btn-total'), { onClick: function () {
    //             var ids = getCheckedIds();
    //             if ( ids )
    //             {
    //               $('choose-date-range').show();
    //             }
    //             else
    //             {
    //                 alert('Please select some row(s) to perform action with !');
    //             }
    //         }, icon: 'money_dollar', caption: 'Total Amount', classes: 'mr10 ml10' });
    // }

    // if ( $('btn-calc-total') ){
    //     new Cubix.Button($('btn-calc-total'), { onClick: function () {
    //             var ids = getCheckedIds();
    //             var date_from = getCheckedDateFrom();
    //             var date_to = getCheckedDateTo();

    //             if ( ids )
    //             {
    //                 popupCount.setTitle('Total Amount');
    //                 popupCount.load('/billing/cam-tokens/calc-total-amount?ids=' + ids+'&date_from='+date_from+'&date_to='+date_to, function () {
    //                     this.open();
    //                 });

    //             }
    //             else
    //             {
    //                 alert('Please select some row(s) to perform action with !');
    //             }
    //         }, icon: 'money_dollar', caption: 'Calculate Total Amount', classes: 'mr10 ml10' });
    // }

    function getCheckedIds()
    {
        var ids = '';
        $$('#cx-grid input[type=checkbox][name=selected\[\]]').each(function(it){
            if ( it.get('id') != 'select-all' && it.get('checked') )
                ids += it.value + ',';
        });

        return ids;
    }
    function getCheckedDateFrom()
    {
        var date = $$('#date_from').get('value');
        return date;
    }
    function getCheckedDateTo()
    {
        var date = $$('#date_to').get('value');
        return date;
    }

    var popupCount = new Cubix.Popup.Ajax({
        abar: [
            { caption: 'Close', icon: 'cancel', action: Cubix.Popup.Actions.Close }
        ],
        width: 300
    });
    // new Cubix.Button($('btn-create'), { onClick: function () {
    //             popupCreateRequest.__mode = 'create';
    //             popupCreateRequest.setTitle('Create New Escort');
    //                 popupCreateRequest.load('<?= $this->baseUrl() ?>/billing/cam-tokens/create', popup.open);

    //     },
    //         icon: 'add', caption: 'Create New Request' }
    //     );
	new Cubix.Shadow($('content'));

	var getFilterParams = function () {
		var uri = new URI('?' + $$('form')[0].toQueryString());
		return uri.get('data');
	};

	var popupCreateRequest = new Cubix.Popup.Ajax({
		abar: [
            { caption: 'Save', icon: 'accept', action: function (result) {
                    (Cubix.Popup.Actions.SaveValid.bind(this))(function (result) {
                        grid.load();
                    });
                } },
			{ caption: 'Close', icon: 'cancel', action: Cubix.Popup.Actions.Close }
		],
		width: 800
	});

	var popup = new Cubix.Popup.Ajax({
		abar: [
			{ caption: 'Close', icon: 'cancel', action: Cubix.Popup.Actions.Close }
		],
		width: 500
	});
    var popupEdit = new Cubix.Popup.Ajax({
        abar: [
            { caption: 'Save', icon: 'accept', action: function (result) {
                    (Cubix.Popup.Actions.SaveValid.bind(this))(function (result) {
                        grid.load();
                    });
                } },
            { caption: 'Close', icon: 'cancel', action: Cubix.Popup.Actions.Close }
        ],
        width: 750,
        zIndex: function () { return Cubix.Popup.zIndex + 8 }
    });
	popup.addEvent('loaded', function () {

	});

	var rejectPopup = new Cubix.Popup.Ajax({
		abar: [
			{ caption: 'Reject', icon: 'delete', action: Cubix.Popup.Actions.SaveValid },
			{ caption: 'Close', icon: 'cancel', action: Cubix.Popup.Actions.Close }
		],
		width: 640,
		zIndex: function () { return Cubix.Popup.zIndex + 20 }
	});
	window.rejectPopup = rejectPopup;


    var menu = new ActionsMenu([
		{	
			name: 'details', icon: 'details', caption: 'details', func: function (data) {
                popup.setTitle('More info');
                popup.load('<?= $this->baseUrl() ?>/billing/cam-tokens/details?request_id=' + data.id, function () {
                    this.open();
                });
            } 
		},
		{ 
			name: 'reject', icon: 'remove', caption: 'Reject', func: function (data) {
				if ( data.status == 'CP Error' || data.status == 'Confirmed' ) { 
					rejectPopup.setTitle('Reject Transfer');
					rejectPopup.load('/billing/cam-tokens/reject?id=' + data.id, function () {
						this.open();
					});
				}
			} 
		}
		
        // { name: 'edit', icon: 'edit', caption: 'Edit', func: function (data) {
        //         popupEdit.__mode = 'edit';
        //         popupEdit.setTitle('Edit');
        //         popupEdit.load('<?= $this->baseUrl() ?>/billing/cam-tokens/edit?id=' + data.id, function () {
        //             this.open();
        //         });
        //     } },
        // { name: 'send_sms', icon: 'quick-sms', caption: 'Send sms', func: defaultAction = function (data) {
        //         if ( confirm('Are you sure you want to send sms to this escort?') ) {
        //             new Request({
        //                 url: '/billing/cam-tokens/send-sms?id=' + data.id,
        //                 onSuccess: function (resp) {
        //                     grid.load();
        //                 }.bind(this)
        //             }).send();
        //         }
        //     } },
        // { name: 'send_email', icon: 'quick-sms', caption: 'Send customer email', func: defaultAction = function (data) {
        //         if ( confirm('Are you sure you want to send email to customer?') ) {
        //             new Request({
        //                 url: '/billing/cam-tokens/send-email-customer?id=' + data.id,
        //                 onSuccess: function (resp) {
        //                     grid.load();
        //                 }.bind(this)
        //             }).send();
        //         }
        //     } },
    ], { icon: 'details', mode: 'mouse' });


	menu.addEvent('show', function (data) {
		if ( data.status == 'CP Error' ||  data.status == 'Confirmed' ) {
			this.actions['reject'].enable();
		}else{
			this.actions['reject'].hide();
		}
	});

	var grid = Cubix.Grid.Instance = new Cubix.Grid('cx-grid', {
		id: 'id',
		identifier: { field: 'id' },
        actions: [{ type: 'details', mouseenter: function (data, btn) {
                menu.show(btn, data);
            } }
        ],
		header: [
            <? if (in_array(Cubix_Application::getId(), array())): ?>{ title: '<input type="checkbox" id="select-all" />', field: '', type: 'Checkbox', width: '15px' },<? endif ?>
            { title: 'Member id', field: 'member_id', type: 'number', sortable: false, width: '70px' },
			{ title: 'Email', field: 'email', type: 'string', sortable: false },			
            { title: 'Transaction id', field: 'transaction_id', type: 'string', sortable: false, width: '110px' },
            { title: 'Amount', field: 'amount', type: 'number', sortable: false, width: '55px' },
			{ title: 'Tokens', field: 'tokens', type: 'number', sortable: false, width: '55px' },
			{ title: 'Status', field: 'status', type: 'TokenTransferStatus', sortable: false, width: '90px' },
            { title: 'Transfer Date', field: 'date_transfered', type: 'DateTime', sortable: true, width: '110px' }
		],
		sort: {
			field: 'id',
			dir: 'desc'
		},
		data: new Cubix.Grid.Loader({ url: '/billing/cam-tokens/data', params: getFilterParams })
	});

	new Cubix.Button($('btn-refresh'), { onClick: function () {
		grid.load();
	}, icon: 'refresh', caption: 'Search', classes: '' });

	grid.addEvent('loaded', function () {
				
		$$('.reject-reason img').addEvent('mouseenter', function(){
			var com = this.getNext('div');
			com.removeClass('none');
		});

		$$('.reject-reason img').addEvent('mouseleave', function(){
			var com = this.getNext('div');
			com.addClass('none');
		});
	});
	
	var clearForm = function() {
		var inputs = $$('.c-filter-form')[0].getElements('input');

		inputs.each(function(input) {
			var input_type = input.get('type');
			if ( input_type != 'hidden' ) {
				if ( input_type == 'text' ) {
					input.set('value', '');
				}
				else {
					input.set('checked', '');
				}
			}
		});

		var selects = $$('.c-filter-form')[0].getElements('select');

		selects.each(function(select) {
			select.set('value', '');
		});
	};

	new Cubix.Button($('btn-reset'), { onClick: function () {
		clearForm();
		grid.load();
	}, icon: 'undo', caption: 'Reset Form', classes: 'ml20' });

	var initFormSubmit = function() {
		var inputs = $$('.c-filter-form')[0].getElements('input');

		inputs.each(function(input) {
			var input_type = input.get('type');

			if ( input_type != 'hidden' ) {
				if ( input_type == 'text' ) {
					input.addEvent('keyup', function(event) {
						if( event.key == 'enter' ) {
							grid.load();
						}
					});
				}
				else {
					input.addEvent('change', function(){
						grid.load();
					});
				}
			}
		});

		var selects = $$('.c-filter-form')[0].getElements('select');

		selects.each(function(it) {
			if ( it.get('name') != 'filter_by' && it.get('name') != 'dates_defined' ) {
				it.addEvent('change', function(){
					grid.load();
				});
			}
		});
	};

	initFormSubmit();

	if ( $('select-all') ) {
        $('select-all').set('checked', '');

        $('select-all').addEvent('click', function() {
            if ( this.get('checked') )
            {
                $$('#cx-grid input[type=checkbox][name=selected\[\]]').each(function(it){
                    if ( it.get('id') != 'select-all' && !it.get('disabled') )
                        it.set('checked', 'checked');
                });
            }
            else
            {
                $$('#cx-grid input[type=checkbox][name=selected\[\]]').each(function(it){
                    if ( it.get('id') != 'select-all' )
                        it.set('checked', '');
                });
            }
        });
    }

   var initDateFilter = function(filter_form){

        date_from_picker = $(filter_form).getElement('.f-date-from');
        var date_from = new Picker.Date(date_from_picker, { pickerClass: 'datepicker',
            positionOffset: { x: -10, y: 0 }, allowEmpty: true, format: 'd M Y' });
        date_to_picker = $(filter_form).getElement('.f-date-to');
        var date_to = new Picker.Date(date_to_picker, { pickerClass: 'datepicker',
                positionOffset: { x: -10, y: 0 }, allowEmpty: true, format: 'd M Y' });

        $(filter_form).getElement('.f-dates-defined').addEvent('change', function() {
            switch(this.get('value'))
            {
                case '':
                    /*date_from.onFocus(date_from.item, date_from.clone, true);
                    date_from.select(date_from.dateToObject(new Date()), true);

                    date_to.onFocus(date_to.item, date_to.clone, true);
                    date_to.select(date_to.dateToObject(new Date()), true);*/
                    $("f-date-from").set('value','');
                    $("f-date-to").set('value','');
                    $$("input[name=date_from]").set('value', '');
                    $$("input[name=date_to]").set('value', '');
                break;
                case 'today':
                    date_from.onFocus(date_from.item, date_from.clone, true);
                    date_from.select(date_from.dateToObject(new Date()));

                    date_to.onFocus(date_to.item, date_to.clone, true);
                    date_to.select(date_to.dateToObject(new Date()));
                break;
                case 'yesterday':
                    date_from.onFocus(date_from.item, date_from.clone, true);
                    date_from.select(date_from.dateToObject(new Date().decrement('day', 1)));

                    date_to.onFocus(date_to.item, date_to.clone, true);
                    date_to.select(date_to.dateToObject(new Date()));
                break;
                case 'last_7_days':
                    date_from.onFocus(date_from.item, date_from.clone, true);
                    date_from.select(date_from.dateToObject(new Date().decrement('day', 7)));

                    date_to.onFocus(date_to.item, date_to.clone, true);
                    date_to.select(date_to.dateToObject(new Date()));
                break;
                case 'this_month':
                    var last_day = new Date().get('lastdayofmonth');

                    date_from.onFocus(date_from.item, date_from.clone, true);
                    date_from.select(date_from.dateToObject(new Date().set('date', 1)));

                    date_to.onFocus(date_to.item, date_to.clone, true);
                    date_to.select(date_to.dateToObject(new Date().set('date', last_day)));
                break;
                case 'last_month':
                    var last_month = new Date().decrement('month', 1);

                    var last_day = last_month.get('lastdayofmonth');

                    date_from.onFocus(date_from.item, date_from.clone, true);
                    date_from.select(date_from.dateToObject(last_month.set('date', 1)));

                    date_to.onFocus(date_to.item, date_to.clone, true);
                    date_to.select(date_to.dateToObject(last_month.set('date', last_day)));
                break;
            }
        });
    };

    initDateFilter('search-form');

    <? if ( strlen($this->filter_params['dates_defined']) > 0 ): ?>
        $('search-form').getElement('.f-dates-defined').set('value', '<?= $this->filter_params['dates_defined'] ?>');
        $('search-form').getElement('.f-dates-defined').fireEvent('change');
    <? endif; ?>
};
</script>

<div class="form-common gray c-filter-form">
	<form id="search-form">
		<fieldset class="inner mb10">
			<legend> Cam </legend>

			<div class="inner">
				<label for="f-transaction_id">Transaction Id</label>
				<input id="f-transaction_id" type="text" class="txt w18" name="transaction_id" value="<?= $this->filter_params['transaction_id'] ?>" />
			</div>
			
			<div class="inner">
				<label for="f-status">Status</label>				
				<select name="status" id="type_id">
					<option value="">-</option>
					<? foreach( Model_Billing_Tokens::$STATUS_LABELS as $id => $title ): ?>
						<option value="<?= $id ?>"><?= $title ?></option>
					<? endforeach; ?>
				</select>
			</div>
			
			<div class="clear"></div>
		</fieldset>

		
		<fieldset class="inner mb10">
			<legend>Members</legend>
			
			<div class="inner">
                <label for="f-member_id">Member ID</label>
                <input id="f-member_id" type="text" class="txt w17" name="member_id" value="<?= $this->filter_params['member_id'] ?>" />
            </div>

            <div class="inner">
                <label for="f-email">Email</label>
                <input id="f-email" type="text" class="txt w18" name="email" value="<?= $this->filter_params['email'] ?>" />
            </div>
			
			
		</fieldset>
        
         <fieldset class="inner mb10">
                <legend>Transfer Dates</legend>

                <div class="inner">
                    <label>Date:</label>
                    <select id="f-dates-defined" name="dates_defined" class="w10 f-dates-defined">
                        <option value=""> - any - </option>
                        <option value="today">Today</option>
                        <option value="yesterday">Yesterday</option>
                        <option value="last_7_days">Last 7 Days</option>
                        <option value="this_month">This Month</option>
                        <option value="last_month">Last Month</option>
                    </select>
                </div>

                <div class="inner">
                    <label>From</label>
                    <input id="f-date-from" type="text" class="txt w8 f-date-from" name="date_from" value="" />
                </div>

                <div class="inner" style="padding-top: 25px">
                    <span> - </span>
                </div>

                <div class="inner">
                    <label>To</label>
                    <input id="f-date-to" type="text" class="txt w8 f-date-to" name="date_to" value="" />
                </div>

                <div class="clear"></div>
            </fieldset>

		<div class="clear"></div>
		<a id="btn-refresh"></a>
		<a id="btn-reset"></a>
        <a href="" id="btn-total"></a>
		<div class="clear"></div>
	</form>
</div><!-- form-common -->


<div class="mt10 fleft">
    
	<!-- <a id="btn-create"></a> -->
	<!-- <a id="btn-total"></a> -->
    
	<div class="clear"></div>
</div>
<br>
<div id="choose-date-range" class="mt10 fleft choose-date-range">
    <form action="<?= $this->baseUrl() ?>/billing/cam-tokens/calc-total-amount" method="post" class="form-common total-amount-form">
        <fieldset>
            <legend>Date Range</legend>
            <div class="row-details">
                <div class="row">
                    <div class="col-md-12">
                        <div class="inner">
                            <label>From</label>
                            <input id="date_from" type="text" class="txt w" name="date_fromaa" value="" />
                        </div>

                        <div class="inner" style="padding-top: 25px">
                            <span> - </span>
                        </div>

                        <div class="inner">
                            <label>To</label>
                            <input id="date_to" type="text" class="txt w8" name="date_toaa" value="" />
                        </div>
                    </div>
                    <!-- <div class="col-md-12">
                        <div class="inner">
                            <a id="btn-calc-total"></a>
                        </div>
                    </div> -->
                </div>
            </div>
        </fieldset>
    </form>
    <div class="clear"></div>
</div>


<div class="clear"></div>

<div id="ajax-dest">
	<div id="cx-grid">
	</div>
</div>
 